package com.javaonpdas.networking;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.io.*;
import javax.microedition.io.*;
import java.util.*;

public class HttpNetworking extends MIDlet
  implements CommandListener {

  private Form mainForm = new Form("");
  private Display display = null;
  private StringItem resultItem = new StringItem("", "");
  private Command getCommand =
    new Command("Get", Command.SCREEN, 1);
  private Command exitCommand =
    new Command("Exit", Command.EXIT, 10);

  public HttpNetworking () {
    mainForm.append(resultItem);
    mainForm.addCommand(getCommand);
    mainForm.addCommand(exitCommand);
    mainForm.setCommandListener(this);
  }

  public void startApp () {
    display = Display.getDisplay(this);
    display.setCurrent(mainForm);
  }

  public void pauseApp () {
  }

  public void destroyApp(boolean unconditional) {
  }

  private String getPage(String url) throws IOException {
    HttpConnection c = null;
    String result = null;
    try {
      c = (HttpConnection)Connector.open(url);
      DataInputStream dis = c.openDataInputStream();
      byte[] buffer = new byte[(int)c.getLength()];
      dis.readFully(buffer);
      result = new String(buffer);
    }
    catch (Exception e) {
      Alert alert = new Alert("Error");
      alert.setString(e.toString());
      alert.setTimeout(Alert.FOREVER);
      display.setCurrent(alert, mainForm);
      System.out.println(e.getMessage());
    }
    finally {
      if(c != null)
        c.close();
    }
    return result;
  }

  public void commandAction(Command c, Displayable d) {
    try {
      if (c == getCommand) {
        resultItem.setLabel("Requesting page...");
        resultItem.setText("");
        String result = getPage(
          "http://users.bigpond.com/ripple/JavaOnPDAs/HttpNetworking.html");
        // String result = getPage(
        //   "http://192.168.0.3:5555/ripple/JavaOnPDAs/HttpNetworking.html");
        resultItem.setLabel("Received...");
        resultItem.setText(result);
      }
      else if (c == exitCommand) {
        destroyApp(false);
        notifyDestroyed();
      }
    }
    catch (Exception e) {
      e.printStackTrace();
      resultItem.setLabel("Error:");
      resultItem.setText(e.toString());
    }
  }
}
