package com.javaonpdas.persistence.threadedrms;

import java.io.*;
import javax.microedition.rms.*;

public class RmsThread extends Thread {

  int count = 0;
  Movie[] movies = null;
  RecordStore store = null;

  public RmsThread(int count, Movie[] movies,
    RecordStore store) {

    this.count = count;
    this.movies = movies;
    this.store = store;
  }

  public void run() {
    try {
      // add the specified number of movies to the record store,
      // sleeping between adds
      for (int i=0; i<count; i++) {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(bos);
        Movie movie = movies[i % movies.length];
        // write the object to the stream
        movie.writeObject(dos);
        byte[] ba = bos.toByteArray();
        store.addRecord(ba, 0, ba.length);
        // now sleep for a while
        sleep(1000);
      }
      store.closeRecordStore();
    }
    catch (Exception e) {
        e.printStackTrace ();
    }
  }
}
