package com.javaonpdas.ui;

import javax.microedition.lcdui.*;

public class AlertMIDlet extends BaseUIMIDlet {

  private Command shortAlertCommand =
    new Command("Short", Command.SCREEN, 1);
  private Command longAlertCommand =
    new Command("Long", Command.SCREEN, 1);
  private Command timedAlertCommand =
    new Command("Timed", Command.SCREEN, 1);
  private Command confirmationAlertCommand =
    new Command("Confirm", Command.SCREEN, 1);
  private Command warningAlertCommand =
    new Command("Warning", Command.SCREEN, 1);
  private Command infoAlertCommand =
    new Command("Info", Command.SCREEN, 1);
  private Command errorAlertCommand =
    new Command("Error", Command.SCREEN, 1);
  private Command alarmAlertCommand =
    new Command("Alarm", Command.SCREEN, 1);
  private Command soundAlertCommand =
    new Command("Sound", Command.SCREEN, 1);

  public AlertMIDlet() {
    super();
    mainForm.setTitle("AlertMIDlet");
    mainForm.addCommand(shortAlertCommand);
    mainForm.addCommand(longAlertCommand);
    mainForm.addCommand(timedAlertCommand);
    mainForm.addCommand(confirmationAlertCommand);
    mainForm.addCommand(warningAlertCommand);
    mainForm.addCommand(infoAlertCommand);
    mainForm.addCommand(errorAlertCommand);
    mainForm.addCommand(alarmAlertCommand);
    mainForm.addCommand(soundAlertCommand);
  }

  public void commandAction(Command c, Displayable d) {
    if (c == shortAlertCommand) {
      Alert alert = new Alert("Alert");
      alert.setTimeout(Alert.FOREVER);
      alert.setString("This is a short string");
      display.setCurrent(alert, mainForm);
    }
    else if (c == longAlertCommand) {
      Alert alert = new Alert("Alert");
      alert.setTimeout(5000);
      alert.setString("This is an alert that is displayed forever because it contains a string that is quite long and therefore the user needs to scroll down to view it. Since scrolling is involved, the alert cannot be automatically closed. If scrolling was not involved, then the timeout would apply as usual. Mind you, the text to fill an alert on a Palm's screen is quite long.");
      display.setCurrent(alert, mainForm);
    }
    else if (c == timedAlertCommand) {
      Alert alert = new Alert("Alert");
      alert.setTimeout(5000);
      alert.setString("This is an alert that is displayed for 5 seconds");
      display.setCurrent(alert, mainForm);
    }
    else if (c == confirmationAlertCommand) {
      Alert alert = new Alert("Alert");
      alert.setTimeout(Alert.FOREVER);
      alert.setString("This is a CONFIRMATION alert");
      alert.setType(AlertType.CONFIRMATION);
      display.setCurrent(alert, mainForm);
    }
    else if (c == warningAlertCommand) {
      Alert alert = new Alert("Alert");
      alert.setTimeout(Alert.FOREVER);
      alert.setString("This is a WARNING alert");
      alert.setType(AlertType.WARNING);
      display.setCurrent(alert, mainForm);
    }
    else if (c == infoAlertCommand) {
      Alert alert = new Alert("Alert");
      alert.setTimeout(Alert.FOREVER);
      alert.setString("This is a INFO alert");
      alert.setType(AlertType.INFO);
      display.setCurrent(alert, mainForm);
    }
    else if (c == errorAlertCommand) {
      Alert alert = new Alert("Alert");
      alert.setTimeout(Alert.FOREVER);
      alert.setString("This is a ERROR alert");
      alert.setType(AlertType.ERROR);
      display.setCurrent(alert, mainForm);
    }
    else if (c == alarmAlertCommand) {
      Alert alert = new Alert("Alert");
      alert.setTimeout(Alert.FOREVER);
      alert.setString("This is a ALARM alert");
      alert.setType(AlertType.ALARM);
      display.setCurrent(alert, mainForm);
    }
    else if (c == soundAlertCommand) {
      Alert alert = new Alert("Alert");
      alert.setTimeout(Alert.FOREVER);
      alert.setString("This is a WARNING sound alert");
      alert.setType(AlertType.WARNING);
      AlertType.WARNING.playSound(display);
      display.setCurrent(alert, mainForm);
    }
    else {
      super.commandAction(c, d);
    }
  }
}
