package com.javaonpdas.ui;

import javax.microedition.lcdui.*;

public class GaugeMIDlet extends BaseUIMIDlet {

  private Command variableGaugeCommand =
    new Command("Variable", Command.SCREEN, 1);
  private Command staticGaugeCommand =
    new Command("Static", Command.SCREEN, 1);

  public GaugeMIDlet() {
    super();
    mainForm.setTitle("GaugeMIDlet");
    mainForm.addCommand(variableGaugeCommand);
    mainForm.addCommand(staticGaugeCommand);
  }

  public void commandAction(Command c, Displayable d) {
    if (c == variableGaugeCommand) {
      Form gaugeForm = new Form("Gauge");
      Gauge guage = new Gauge("Value", true, 20, 5);
      gaugeForm.append(guage);
      gaugeForm.addCommand(okCommand);
      gaugeForm.addCommand(backCommand);
      gaugeForm.setCommandListener(this);
      display.setCurrent(gaugeForm);
    }
    if (c == staticGaugeCommand) {
      Form gaugeForm = new Form("Gauge");
      Gauge guage = new Gauge("Value", false, 20, 5);
      gaugeForm.append(guage);
      gaugeForm.addCommand(backCommand);
      gaugeForm.setCommandListener(this);
      display.setCurrent(gaugeForm);
    }
    else if (c == okCommand) {
      Form gaugeForm = (Form)d;
      Gauge gauge = (Gauge)(gaugeForm.get(0));
      int value = gauge.getValue();
      // display the result
      Alert alert = new Alert("Gauge Value");
      alert.setString("The selected value is " + value);
      alert.setTimeout(5000);
      alert.setType(AlertType.INFO);
      display.setCurrent(alert, mainForm);
    }
    else if (c == backCommand) {
      display.setCurrent(mainForm);
    }
    else {
      super.commandAction(c, d);
    }
  }
}
