package com.javaonpdas.ui;

import javax.microedition.lcdui.*;

public class ListMIDlet extends BaseUIMIDlet {

  private Command exclusiveListCommand =
    new Command("Exclusive", Command.SCREEN, 1);
  private Command implicitListCommand =
    new Command("Implicit", Command.SCREEN, 1);
  private Command multipleListCommand =
    new Command("Multiple", Command.SCREEN, 1);

  public ListMIDlet() {
    super();
    mainForm.setTitle("ListMIDlet");
    mainForm.addCommand(exclusiveListCommand);
    mainForm.addCommand(implicitListCommand);
    mainForm.addCommand(multipleListCommand);
  }

  public void commandAction(Command c, Displayable d) {
    if (c == exclusiveListCommand) {
      List list =
        new List("Movies", List.EXCLUSIVE, MOVIES, null);
      list.addCommand(okCommand);
      list.addCommand(backCommand);
      list.setCommandListener(this);
      display.setCurrent(list);
    }
    else if (c == implicitListCommand) {
      List list =
        new List("Movies", List.IMPLICIT, MOVIES, null);
      list.addCommand(okCommand);
      list.addCommand(backCommand);
      list.setCommandListener(this);
      display.setCurrent(list);
    }
    else if (c == multipleListCommand) {
      List list =
        new List("Movies", List.MULTIPLE, MOVIES, null);
      list.addCommand(okCommand);
      list.addCommand(backCommand);
      list.setCommandListener(this);
      display.setCurrent(list);
    }
    else if (c == okCommand) {
      List list = (List)d;
      String movieSelected = new String();
      boolean[] selections = new boolean[list.size()];
      list.getSelectedFlags(selections);
      for (int i=0; i<selections.length; i++)
        if (selections[i])
          movieSelected += list.getString(i) + "\n";
      // display the result
      Alert alert = new Alert("Selection");
      alert.setString(movieSelected);
      alert.setTimeout(5000);
      alert.setType(AlertType.INFO);
      display.setCurrent(alert, mainForm);
    }
    else if (c == backCommand) {
      display.setCurrent(mainForm);
    }
    else {
      super.commandAction(c, d);
    }
  }
}
