package com.javaonpdas.webservices.clients.custom;

import java.util.Date;

import java.io.InputStream;
import java.io.DataInputStream;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;

import com.javaonpdas.SnapShot;

public class HTTPStreamClient extends MIDlet
  implements CommandListener {

  private Form mainForm = new Form("");
  private Display display = null;
  private Command exitCommand =
    new Command("Exit", Command.EXIT, 10);
  private Command getNamesCommand =
    new Command("Get Names", Command.SCREEN, 1);
  private Command getImageCommand =
    new Command("Get Image", Command.SCREEN, 2);
  private TextField textField =
    new TextField(null, null, 10000, TextField.ANY);
  private ImageItem imageItem =
    new ImageItem("Image",
                  Image.createImage(Image.createImage(10,10)),
                  ImageItem.LAYOUT_DEFAULT, "No image yet");

  public HTTPStreamClient() {
    mainForm.append(textField);
    mainForm.append(imageItem);
    mainForm.addCommand(getNamesCommand);
    mainForm.addCommand(getImageCommand);
    mainForm.addCommand(exitCommand);
    mainForm.setCommandListener(this);
  }

  public void startApp() {
    display = Display.getDisplay(this);
    display.setCurrent(mainForm);
  }

  public void pauseApp() {
  }

  public void destroyApp(boolean unconditional) {
  }

  public void commandAction(Command c, Displayable d) {
    if (c == getNamesCommand) {
      HttpConnection connection = null;
      DataInputStream dis = null;
      String url = "http://192.168.0.3:8080/javaonpdas/servlet/ImageServiceStreamProxy?service-end-point=http://localhost:8080/axis/servlet/AxisServlet&action=getNames";
      try {
        connection = (HttpConnection)Connector.open(url);
        connection.setRequestMethod(HttpConnection.GET);
        dis = connection.openDataInputStream();
        int numberOfNames = dis.readInt();
        textField.setString(null);
        for (int i=0; i<numberOfNames; i++) {
          String name = dis.readUTF();
          textField.insert(name + "\n", textField.size());
        }
      }
      catch (Exception e) {
        textField.insert("Error:" + e.toString() + "\n",
                         textField.size());
      }
      finally {
        try {
          if (connection != null) connection.close();
          if (dis != null) dis.close();
        } catch (Exception e) {}
      }
    }
    else if (c == getImageCommand) {
      SnapShot snapshot = new SnapShot();
      snapshot.snap();
      HttpConnection connection = null;
      DataInputStream dis = null;
      String url = "http://192.168.0.3:8080/javaonpdas/servlet/ImageServiceStreamProxy?service-end-point=http://localhost:8080/axis/servlet/AxisServlet&action=getImage&name=kangaroo1.png";
      try {
        connection = (HttpConnection)Connector.open(url);
        connection.setRequestMethod(HttpConnection.GET);
        int contentLength = (int)connection.getLength();
        if (contentLength>0) {
          dis = connection.openDataInputStream();
          byte[] imageByteArray = new byte[contentLength];
          int ch = 0;
          for (int i=0; i<contentLength; i++) {
            if ((ch = dis.read()) != -1) {
              imageByteArray[i] = (byte)ch;
            }
            else {
              textField.insert("Error: encountered EOF\n",
                               textField.size());
            }
          }
          imageItem.setImage(Image.createImage(imageByteArray,
                             0, imageByteArray.length));
        }
      }
      catch (Throwable t) {
        textField.insert("Error:" + t.toString() + "\n",
                         textField.size());
        t.printStackTrace();
      }
      finally {
        try {
          if (dis != null) dis.close();
          if (connection != null) connection.close();
         } catch (Exception e) {}
      }
      snapshot.snap();
    }
    else if (c == exitCommand) {
      destroyApp(false);
      notifyDestroyed();
    }
  }
}
