package com.javaonpdas.webservices.clients.custom;

import java.util.Date;

import java.io.InputStream;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;

import com.javaonpdas.SnapShot;

public class HTTPTextClient extends MIDlet
  implements CommandListener {

  private Form mainForm = new Form("");
  private Display display = null;
  private Command exitCommand =
    new Command("Exit", Command.EXIT, 10);
  private Command getNamesCommand =
    new Command("Get Names", Command.SCREEN, 1);
  private Command getImageCommand =
    new Command("Get Image", Command.SCREEN, 2);
  private TextField textField =
    new TextField(null, null, 10000, TextField.ANY);
  private ImageItem imageItem =
    new ImageItem("Image", Image.createImage(
      Image.createImage(10,10)),
      ImageItem.LAYOUT_DEFAULT, "No image yet");

  public HTTPTextClient() {
    mainForm.append(textField);
    mainForm.append(imageItem);
    mainForm.addCommand(getNamesCommand);
    mainForm.addCommand(getImageCommand);
    mainForm.addCommand(exitCommand);
    mainForm.setCommandListener(this);
  }

  public void startApp() {
    display = Display.getDisplay(this);
    display.setCurrent(mainForm);
  }

  public void pauseApp() {
  }

  public void destroyApp(boolean unconditional) {
  }

  public void commandAction(Command c, Displayable d) {
    if (c == getNamesCommand) {
      HttpConnection connection = null;
      InputStream is = null;
      String url = "http://192.168.0.3:8080/javaonpdas/servlet/ImageServiceProxy?service-end-point=http://localhost:8080/axis/servlet/AxisServlet&action=getNames";
      try {
        connection = (HttpConnection)Connector.open(url);
        connection.setRequestMethod(HttpConnection.GET);
        is = connection.openInputStream();
        int contentLength = (int)connection.getLength();
        if (contentLength != 0) {
          byte[] byteArray = new byte[contentLength];
          is.read(byteArray);
          StringBuffer buffer = new StringBuffer();
          textField.setString(null);
          for (int i=0; i<byteArray.length; i++) {
            if (byteArray[i] == (byte)'\n') {
              textField.insert(buffer.toString() + "\n",
                textField.size());
              buffer.setLength(0);
            }
            else if (byteArray[i] == (byte)'\r') {
            }
            else {
              buffer.append((char)byteArray[i]);
            }
          }
        }
      }
      catch (Exception e) {
        textField.insert("Error:" + e.toString() + "\n",
          textField.size());
      }
      finally {
        try {
          if (connection != null) connection.close();
          if (is != null) is.close();
         } catch (Exception e) {}
      }
    }
    else if (c == getImageCommand) {
      SnapShot snapshot = new SnapShot();
      snapshot.snap();
      HttpConnection connection = null;
      InputStream is = null;
      String url = "http://192.168.0.3:8080/javaonpdas/servlet/ImageServiceProxy?service-end-point=http://localhost:8080/axis/servlet/AxisServlet&action=getImage&name=kangaroo1.png";
      System.out.println("requesting " + url);
      try {
        connection = (HttpConnection)Connector.open(url);
        connection.setRequestMethod(HttpConnection.GET);
        is = connection.openInputStream();
        int contentLength = (int)connection.getLength();
        System.out.println("content length: " + contentLength);
        if (contentLength > 0) {
          byte[] byteArray = new byte[contentLength];
          is.read(byteArray);
          StringBuffer buffer =
            new StringBuffer(byteArray.length);
          textField.setString(null);
          int fieldNumber = 1;
          for (int i=0; i<byteArray.length; i++) {
            if (byteArray[i] == (byte)'\n') {
              if (fieldNumber == 1) {
                Date date =
                  new Date(Long.parseLong(buffer.toString()));
              }
              else if (fieldNumber == 2) {
                byte[] imageByteArray =
                  org.kobjects.base64.Base64.decode(
                    buffer.toString());
                imageItem.setImage(Image.createImage(
                  imageByteArray, 0, imageByteArray.length));
              }
              buffer.setLength(0);
              fieldNumber++;
            }
            else if (byteArray[i] == (byte)'\r') {
            }
            else {
              buffer.append((char)byteArray[i]);
            }
          }
        }
      }
      catch (Throwable t) {
        textField.insert("Error:" + t.toString() + "\n",
          textField.size());
        t.printStackTrace();
      }
      finally {
        try {
          if (connection != null) connection.close();
          if (is != null) is.close();
         } catch (Exception e) {}
      }
      snapshot.snap();
    }
    else if (c == exitCommand) {
      destroyApp(false);
      notifyDestroyed();
    }
  }
}
