package com.javaonpdas.persistence;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class FileIO extends Frame implements ActionListener {

  TextArea textArea = null;
  Button saveButton = null;
  File file = null;

  public FileIO(String title) {
    super(title);
    // handle frame closing events
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    } );
    setLayout(new FlowLayout(FlowLayout.LEFT, 10, 10));
    Button button = new Button("Open");
    add(button);
    button.addActionListener(this);
    textArea = new TextArea(12,28);
    add(textArea);
    saveButton = new Button("Save");
    add(saveButton);
    saveButton.addActionListener(this);
  }

  public void actionPerformed(ActionEvent evt) {
    String cmd = evt.getActionCommand();
    if (cmd.startsWith("Open")) {
      FileDialog dialog = new FileDialog(this, "Open a file",
        FileDialog.LOAD);
      dialog.show();
      // open and read the file
      String filename = dialog.getFile();
      String directory = dialog.getDirectory();
      BufferedReader in = null;
      try {
        file = new File(directory, filename);
        in = new BufferedReader(new FileReader(file));
        String fileLine = null;
        textArea.setText("");
        for (;;) {
          fileLine = in.readLine();
          if (fileLine == null)
            break;
          else
            textArea.append(fileLine + "\n");
        }
      }
      catch (IOException e) {
        textArea.setText("Error: " + e.getMessage());
      }
      finally {
        try {
          if (in != null) in.close();
        } catch (IOException e) {}
      }
    }
    else {
      // save the text area into the same file
      BufferedWriter out = null;
      try {
        out = new BufferedWriter(new FileWriter(file));
        out.write(textArea.getText());
      }
      catch (IOException e) {
        textArea.setText("Error: " + e.getMessage());
      }
      finally {
        try {
          if (out != null) out.close();
        } catch (IOException e) {}
      }
    }
  }

  public static void main(String[] args) {
    Frame f = new FileIO("FileIO");
    f.setSize(f.getToolkit().getScreenSize());
    f.show();
  }
}
